
#ifndef __SFR_OFFSET
#define __SFR_OFFSET 0
#endif
#include "avr/interrupt.h"

#define nop2     rjmp    .+0 /* jump to next instruction */

#if tty
#define SER_INTR_VECTOR  SIG_USART0_RX // SIG_INTERRUPT1 YM
    .text
    .global SER_INTR_VECTOR
    .type   SER_INTR_VECTOR, @function
#endif

    .global setdlmnbl

;----------------------------------------------------------------------------
; Utility functions
;----------------------------------------------------------------------------

#define argCh   r22 // argument 2
#define argDpL  r24 // argument 1
#define argDpH  r25 // argument 1
#define resSdL  r24 // result
#define resSdH  r25 // result

; uchar setdlmnbl(uchar *delmt, uchar ch);
setdlmnbl:
    mov     ZH, argDpH  ; r25
    mov     ZL, argDpL  ; r24
    mov     r24, argCh  ; r22
    st      Z, argCh    ; *delmt = ch;
    rcall   nibbl       ; return nibbl(ch);
    ldi     resSdH, 0   ; r25
    ret

;----------------------------------------------------------------------------
; Interrupt code
;----------------------------------------------------------------------------

#define SER_CTS_IOPORTNAME  D
#define CTSBIT              3
#define SER_RTS_IOPORTNAME  A
#define RTSBIT              1
#define SER_CONCAT(a, b)    a ## b
#define SER_OUTPORT(name)   SER_CONCAT(PORT, name)
#define SEROUT              SER_OUTPORT(SER_CTS_IOPORTNAME)
#define SER_INPORT(name)    SER_CONCAT(PIN, name)
#define SERIN               USB_INPORT(SER_RTS_IOPORTNAME)

#if tty
SER_INTR_VECTOR:
    push    YL          ; r28
    in      YL, SREG
    push    YL
    push    r24
    sbis    UCSRA, RXC	; if(UCSRA & (1<<RXC))
    rjmp    intrret
    sbi     SEROUT, CTSBIT  ; PORTD |= (1<<PD3);
    in      r24, UDR
    sts     ttyibf, r24 ; ttyibf = UDR;
    ldi     r24, 1
    sts     ttysts, r24 ; ttysts = 1;
    cbi     UCSRB, RXCIE
intrret:
    pop     r24
    pop     YL
    out     SREG, YL
    pop     YL
    reti
#endif
