// Name: main.c
// char    MYD_id[]=
// " sphLtest.C 2009/11/12  MORIYOSHI DENSHI CO.,LTD. COPYRIGHT(C) OCT.2009 ";
// License: GNU GPL v2
// avr Tiny2313 12MHz
// fuse L:E0(11100000) H:DF(11011111) E:01(00000001) // External Clock
// fuse L:FF(11111111) H:DF(11011111) E:01(00000001) // XTAL
//   or L:CF(11001111) H:DF(11011111) E:01(00000001) // CEROLOCK

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <string.h>

#ifndef uchar
#define uchar   unsigned char
#endif

#define WORD unsigned int

uchar usstxd, ussrxd, usscmnd, slvtrg;
uchar usslvsts; // b7:exist send data b6:exist receive data b5:command received

void  coninit() {
    // initialize hardware
#if tty
    PORTA = 0x02;    // PA1 High output
    DDRA = (1<<PA1); // PA1 output //DESC033
    PORTD = 0x7E;    // all pullups include PD1,PD3 high output except PD0(RXD)
    DDRD = (1<<PD1)  // all inputs include RXD(PD0 TxD)
         | (1<<PD3); // except TXD(PD1 RxD),PD3(~CTS) output
    PORTB = 0x0F;    // all pullups except PB4(~RTS),PB5,PB7(SCK)
    DDRB = 0; // all inputs include PB4(~RTS),PB5(MOSI) except PB6(MISO) output //DESC033c

    // USART configuration : 9600bps 8N1
    UBRRL  = 78-1;
    UCSRB  = (1<<RXEN) | (1<<TXEN) | (1<<RXCIE);
#else
    PORTA = 0x02;    // PA1 High output
    DDRA = (1<<PA1); // PA1 output //DESC033
    PORTD = 0x7F;    // all pullups
    PORTB = 0x1F;    // all pullups except PB5,PB7(SCK)
    DDRB = 0;        // all inputs include PB5(MOSI) except PB6(MISO) output //DESC033c
    //@ PORTB = 0x15;    // all pullups except PB5, PB7
    //@ DDRB = (1<<PB6) | 0x1F; // all inputs include PB5(~RTS) except PB6(~CTS) output
#endif
}

void cmndprcs(uchar cmnd) {
}

void ussinit() {
        PORTB &= ~(1<<PB7); // pull-up off
        while( !(PINB & (1<<PB7)) ) ;
        usslvsts = 0;
        slvtrg = 0;
}

void waitc21(uchar i) {
        for(; i--;) PORTB &= ~(1<<PB7); // wait 5:2.1u 4:1.7u 17:7.1u SEC.
}

uchar ussint2() { uchar bfusicnt, i;
        if(PINB & (1<<PB7)) return 1;
        DDRB |= (1<<PB6); //DESC033c
//      PORTA &= ~(1<<PA1); //DESC033b
        USICR = (1<<USIWM0) | (1<<USICS1);
        //USIDR = stsflg; // 0xFF:data 0:status
        USIDR = (usslvsts & (1<<7)) ? 0xFF : 0;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli();
        PORTB |= (1<<PB7); // pull-up on
        while( !(USISR & 0x0F) ) ;
        //cmndflg = USIDR; // LSB 1:data 0:command
        if(USIDR & (1<<0)) usslvsts &= ~(1<<5); else usslvsts |= (1<<5);
        //USIDR = usstxd;
        USIDR = (usslvsts & (1<<7)) ? usstxd : usslvsts;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        sei(); //@ cli();

        do{
            //@ PORTB = (USISR & 0x0F) | 0x80; // debug LED
        } while( !((bfusicnt = USISR) & (1<<USIOIF)) );
        for(i = 0; i++ < 3;) { uchar bytdmy; // one loop 12 clock (24 clock = 2.0u SEC.)
            PORTB |= (1<<PB7); // pull-up on // +2 clock
            if((uchar)(bytdmy= ((bfusicnt ^ USISR) & 0x0F) )) i = 0, bfusicnt = USISR;
        }
        if(USISR & 0x0F) { // error
            PORTB &= ~(1<<PB7); // pull-up off
            USICR = 0;
            return 2;
        }
        //ussrxd = USIDR;
        if(usslvsts & (1<<5)) usscmnd = USIDR;
            else ussrxd = USIDR, usslvsts |= (1<<6);
        DDRB &= ~(1<<PB6); //DESC033c
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        PORTB &= ~(1<<PB7); // pull-up off
        while( !(USISR & 0x0E) ) ; // 2 times occurred
        USICR = 0;
//      PORTA |= (1<<PA1); //DESC033b
        usslvsts &= ~(1<<7);
        waitc21(5); // wait 2.1u SEC.
        return 0;
}

uchar ussint3() { // slave trigger
        //PORTB &= ~(1<<PB7); // pull-up off
        DDRB |= (1<<PB7);
        waitc21(17); // wait 7.1u SEC.
        DDRB &= ~(1<<PB7);
        waitc21(4); // wait 1.7u SEC.
        if(PINB & (1<<PB7)) return 1;
        waitc21(5); // wait 2.1u SEC.
        return 0;
}

        uchar conots();
uchar conins() { uchar i; // return val. : ready
        if(usslvsts & (1<<6)) return 1;
        if(slvtrg) {conots(); return 0;}
        if(PINB & (1<<PB7)) {
           if(usslvsts & (1<<7)) {slvtrg = 1; conots();} // slave trigger
           return 0;
        }
idoltp: for(i = 0; i++ < 2;) {
            if(PINB & (1<<PB7)) return 0; }
        waitc21(5); // wait 2.1u SEC.
        if(ussint2()) goto idoltp;
        if(usslvsts & (1<<5)) {
            cmndprcs(usscmnd);
        }
        if(usslvsts & (1<<6)) return 1;
        return 0;
}

uchar coninp() {
    while(1) {
        if(usslvsts & (1<<6)) { usslvsts &= ~(1<<6); return ussrxd;}
        while( !conins()) ;
    }
}

uchar conots() { uchar i; // return val. : busy
        if( !slvtrg) if( !(usslvsts & (1<<6)) ) conins();
        slvtrg = 0;
        if( !(usslvsts & (1<<7)) ) return 0;
        if(ussint3()) {slvtrg = 1; return 1;}
idoltp: for(i = 0; i++ < 2;) {
            if(PINB & (1<<PB7)) return 1; }
        waitc21(5); // wait 2.1u SEC.
        if(ussint2()) goto idoltp;
        return (usslvsts & (1<<7));
}

void  conout(uchar dat) {
        while(conots()) ;
        usstxd = dat;
        usslvsts |= (1<<7);
}

#if tty
uchar ttysts, ttyibf;

/*void  ttyintr() {
    if(ttysts) {
        if(!(PIND & (1<<PD3)))
            PORTD |= (1<<PD3);
    }else{
        if(UCSRA & (1<<RXC)) {
            ttyibf = UDR;
            ttysts = 1;
            PORTD |= (1<<PD3);
        }else{
            PORTD &= ~(1<<PD3);
        }
    }
}*/

uchar ttyins() { // return val. : ready
//  ttyintr();
    cli();
    if(!ttysts && !(UCSRA & (1<<RXC)) ) PORTD &= ~(1<<PD3);
    sei();
    return ttysts;
}

uchar ttyinp() { uchar dat;
    while( !ttyins()) ;
    cli();
    ttysts = 0;
    dat = ttyibf;
    PORTD &= ~(1<<PD3);
    UCSRB |= (1<<RXCIE);
    sei();
//  ttyintr();
    return dat;
}

uchar ttyots() { // return val. : not ready
//  ttyintr();
    return (~UCSRA & (1<<UDRE)) | (PINB & (1<<PB4));
}

void  ttyout(uchar dat) {
    while( ttyots()) ;
    UDR = dat;
}
#endif

void  crlf() {
//  conout('\r'); // 0x0D enter
    conout('\n'); // 0x0A ^J
}

void  hxd(uchar dat) {
    dat &= 0x0F;
    if(dat >= 10) dat += ('A'-'0'-10);
    conout(dat + '0');
}

void  lbyte(uchar dat) {
    hxd(dat >> 4);
    hxd(dat);
}

void  ladr(WORD dat) {
    lbyte(dat >> 8);
    lbyte(dat & 0x00FF);
}

void  mesot(char *str) { uchar dat;
    while(1) {
        dat = pgm_read_byte(str);
        if(!dat) break;
        conout(dat); str++;
    }
}

uchar txtin() { uchar dat;
    dat = coninp();
    if(dat < 0x20) return dat; // control code
    conout(dat);
    if(dat >= 'a' && dat < 'z'+1) dat -= 'a'-'A';
    return dat;
}

uchar nibbl(uchar dat) {
    dat -= '0';
    if(dat < 10) return dat;
    dat += '0'-'A'+10;
    if(dat >= 10 && dat < 16) return dat;
    return 0x10;
}

extern uchar setdlmnbl(uchar *delmt, uchar ch);
/*uchar setdlmnbl(uchar *delmt, uchar ch) {
    *delmt = ch;
    return nibbl(ch);
}*/

WORD  expr1(uchar *delmt) { WORD dat; uchar ch;
    dat = 0;
    while(1) {
        ch = txtin();
//      *delmt = ch;
//      ch = nibbl(ch);
        ch = setdlmnbl(delmt, ch);
        if(ch >= 0x10) break;
        dat <<= 4;
        dat |= ch;
    }
    return dat;
}

PROGMEM char headmes[] = "avr HS-monitor\n";

int main(void) {
    uchar ch;

    coninit();
    ussinit();

/*/@    conout(0x5A);
    while(1) {
        while(PINB & (1<<PB7)) ; ch = coninp();
        //@ PORTB = (ch & 0x0F) | 0x10; // debug LED
        conout(ch ^ 0xFF); ch = coninp(); conout(ch);
    }*/

    sei();
ts: while(1) {
        ch = coninp();
        if(ch == 0x1B) break; // esc
        conout(ch);
        if(ch != '\n') conout(ch); // 0x0A
    }
    crlf();
    mesot((char *)headmes);
    while(1) {
        conout('.');
        ch = txtin();
        if(ch == 0x03) goto ts; // ^C
        if(ch == 'I') { WORD adr;
            adr = expr1(&ch);
            if(ch < 0x20) conout(' ');
            ladr(adr);
            conout('=');
            lbyte(_MMIO_BYTE(adr)); // 0x20-5F:IO 0x60-DF:RAM
            if(ch == '\r') crlf();
        }else{
            if(ch == '\r') crlf();
            if(ch == '\n') conout(' ');
            conout('x');
            lbyte(ch);
        }
    }
}

/************************************************************************************/
/* test 4.4
uchar usstxd, ussrxd, usscmnd, slvtrg;
//uchar usstrgcnt;
uchar usslvsts; // b7:exist send data b6:exist receive data b5:command received

    PORTB = 0x15;    // all pullups except PB5, PB7
    DDRB = (1<<PB6) | 0x1F; // all inputs include PB5(~RTS) except PB6(~CTS) output


void cmndprcs(uchar cmnd) {
}

void ussinit() {
        PORTB &= ~(1<<PB7); // pull-up off
        while( !(PINB & (1<<PB7)) ) ;
        usslvsts = 0;
        slvtrg = 0;
}

void waitc21(uchar i) {
        for(; i--;) PORTB &= ~(1<<PB7); // wait 5:2.1u 4:1.7u 17:7.1u SEC.
}

uchar ussint2() { uchar bfusicnt, i;
        if(PINB & (1<<PB7)) return 1;
        USICR = (1<<USIWM0) | (1<<USICS1);
        //USIDR = stsflg; // 0xFF:data 0:status
        USIDR = (usslvsts & (1<<7)) ? 0xFF : 0;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli();
        PORTB |= (1<<PB7); // pull-up on
        while( !(USISR & 0x0F) ) ;
        //cmndflg = USIDR; // LSB 1:data 0:command
        if(USIDR & (1<<0)) usslvsts &= ~(1<<5); else usslvsts |= (1<<5);
        //USIDR = usstxd;
        USIDR = (usslvsts & (1<<7)) ? usstxd : usslvsts;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli(); // sei();

        do{
            PORTB = (USISR & 0x0F) | 0x80; // debug LED
        } while( !((bfusicnt = USISR) & (1<<USIOIF)) );
        for(i = 0; i++ < 4;) { uchar bytdmy; // one loop 11 clock (33 clock = 2.7u SEC.)
            if((uchar)(bytdmy= ((bfusicnt ^ USISR) & 0x0F) )) i = 0, bfusicnt = USISR;
        }
        if(USISR & 0x0F) { // error
            PORTB &= ~(1<<PB7); // pull-up off
            USICR = 0;
            return 2;
        }
        //ussrxd = USIDR;
        if(usslvsts & (1<<5)) usscmnd = USIDR;
            else ussrxd = USIDR, usslvsts |= (1<<6);
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        PORTB &= ~(1<<PB7); // pull-up off
        while( !(USISR & 0x0E) ) ; // 2 times occurred
        USICR = 0;
        usslvsts &= ~(1<<7);
        waitc21(5); // wait 2.1u SEC.
        return 0;
}

void ussint1(uchar st) { uchar i;
        if(st) goto slvt;
idoltp:
        for(i = 0; i++ < 2;) {
            if(PINB & (1<<PB7)) goto idoltp; }
        waitc21(5); // wait 2.1u SEC.
slvt:
        if(ussint2()) goto idoltp;
}

uchar ussint3() { // slave trigger
        //PORTB &= ~(1<<PB7); // pull-up off
        DDRB |= (1<<PB7);
        waitc21(17); // wait 7.1u SEC.
        DDRB &= ~(1<<PB7);
        waitc21(4); // wait 1.7u SEC.
        if(PINB & (1<<PB7)) return 1;
        waitc21(5); // wait 2.1u SEC.
        return 0;
}

        uchar conots();
uchar conins() { uchar i; // return val. : ready
        if(usslvsts & (1<<6)) return 1;
        if(slvtrg) {conots(); return 0;}
        if(PINB & (1<<PB7)) {
           if(usslvsts & (1<<7)) {slvtrg = 1; conots();} // slave trigger
           return 0;
        }
idoltp: for(i = 0; i++ < 2;) {
            if(PINB & (1<<PB7)) return 0; }
        waitc21(5); // wait 2.1u SEC.
        if(ussint2()) goto idoltp;
        if(usslvsts & (1<<5)) {
            cmndprcs(usscmnd);
        }
        if(usslvsts & (1<<6)) return 1;
        return 0;
}

uchar coninp() {
    while(1) {
        if(usslvsts & (1<<6)) { usslvsts &= ~(1<<6); return ussrxd;}
        while( !conins()) ;
    }
}

uchar conots() { uchar i; // return val. : busy
        if( !slvtrg) if( !(usslvsts & (1<<6)) ) conins();
        slvtrg = 0;
        if( !(usslvsts & (1<<7)) ) return 0;
        if(ussint3()) {slvtrg = 1; return 1;}
idoltp: for(i = 0; i++ < 2;) {
            if(PINB & (1<<PB7)) return 1; }
        waitc21(5); // wait 2.1u SEC.
        if(ussint2()) goto idoltp;
        return (usslvsts & (1<<7));
}

void  conout(uchar dat) {
        while(conots()) ;
        usstxd = dat;
        usslvsts |= (1<<7);
}

int main(void) {
    uchar ch;
    coninit();
    ussinit();
    conout(0x5A);
    while(1) {
        while(PINB & (1<<PB7)) ;
        ch = coninp();
        PORTB = (ch & 0x0F) | 0x10; // debug LED
        conout(ch ^ 0xFF);
        ch = coninp();
        conout(ch);
    }
*/
/* test 4.2
uchar usstxd, ussrxd, usscmnd;
uchar usslvsts; // b7:exist send data b6:exist receive data b5:command received

    PORTB = 0x15;    // all pullups except PB5, PB7
    DDRB = (1<<PB6) | 0x1F; // all inputs include PB5(~RTS) except PB6(~CTS) output

void ussinit() {
        PORTB &= ~(1<<PB7); // pull-up off
        while( !(PINB & (1<<PB7)) ) ;
        usslvsts = 0;
}

uchar ussint2() { uchar bfusicnt, i;
        if(PINB & (1<<PB7)) return 1;
        USICR = (1<<USIWM0) | (1<<USICS1);
        //USIDR = stsflg; // 0xFF:data 0:status
        USIDR = (usslvsts & (1<<7)) ? 0xFF : 0;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli();
        PORTB |= (1<<PB7); // pull-up on
        while( !(USISR & 0x0F) ) ;
        //cmndflg = USIDR; // LSB 1:data 0:command
        if(USIDR & (1<<0)) usslvsts &= ~(1<<5); else usslvsts |= (1<<5);
        //USIDR = usstxd;
        USIDR = (usslvsts & (1<<7)) ? usstxd : usslvsts;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli(); // sei();

        do{
            PORTB = (USISR & 0x0F) | 0x80; // debug LED
        } while( !((bfusicnt = USISR) & (1<<USIOIF)) );
        for(i = 0; i++ < 4;) { uchar bytdmy; // one loop 11 clock (33 clock = 2.7u SEC.)
            if((uchar)(bytdmy= ((bfusicnt ^ USISR) & 0x0F) )) i = 0, bfusicnt = USISR;
        }
        if(USISR & 0x0F) { // error
            PORTB &= ~(1<<PB7); // pull-up off
            USICR = 0;
            return 2;
        }
        //ussrxd = USIDR;
        if(usslvsts & (1<<5)) usscmnd = USIDR;
            else ussrxd = USIDR, usslvsts |= (1<<6);
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        PORTB &= ~(1<<PB7); // pull-up off
        while( !(USISR & 0x0E) ) ; // 2 times occurred
        USICR = 0;
        usslvsts &= ~(1<<7);
        return 0;
}

void waitc21(uchar i) {
        for(; i--;) PORTB &= ~(1<<PB7); // wait 5:2.1u 4:1.7u 17:7.1u SEC.
}

void ussint1(uchar st) { uchar i;
        if(st) goto slvt;
idoltp:
        for(i = 0; i++ < 2;) {
            if(PINB & (1<<PB7)) goto idoltp; }
        waitc21(5); // wait 2.1u SEC.
slvt:
        if(ussint2()) goto idoltp;
}

uchar ussint3() { // slave trigger
        //PORTB &= ~(1<<PB7); // pull-up off
        DDRB |= (1<<PB7);
        waitc21(17); // wait 7.1u SEC.
        DDRB &= ~(1<<PB7);
        waitc21(4); // wait 1.7u SEC.
        if(PINB & (1<<PB7)) return 1;
        waitc21(5); // wait 2.1u SEC.
        return 0;
}

    ussinit();
    usstxd = 0x5A;
    while(1) { uchar tst1;
        tst1 = 0;
        usslvsts |= (1<<7);
        ussint1(0);
slvt:
        usstxd = ussrxd;
        PORTB = (usstxd & 0x0F) | 0x10; // debug LED

        if(!tst1) {
            tst1 = 1;
            usstxd ^= 0xFF;
            waitc21(5); // wait 2.1u SEC.
slvs:
            if(ussint3()) goto slvs;
            usslvsts |= (1<<7);
            ussint1(1);
            goto slvt;
        }
    }
*/
/* test 4
    PORTB = 0x15;    // all pullups except PB5, PB7
    DDRB = (1<<PB6) | 0x1F; // all inputs include PB5(~RTS) except PB6(~CTS) output

    PORTB &= ~(1<<PB7); // pull-up off
    while( !(PINB & (1<<PB7)) ) ;
    rcvdat = 0x5A;
    while(1) { uchar bfusicnt, i, cmndflg, tst1;
        tst1 = 0;
idoltp: for(i = 0; i++ < 2;) {
            if(PINB & (1<<PB7)) goto idoltp; }
        for(i=5; i--;) PORTB &= ~(1<<PB7); // wait 2.1u SEC.
srvt:   if(PINB & (1<<PB7)) goto idoltp;
        USICR = (1<<USIWM0) | (1<<USICS1);
        USIDR = 0xFF; // 0xFF:data 0:status
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli();
        PORTB |= (1<<PB7); // pull-up on
        while( !(USISR & 0x0F) ) ;
        cmndflg = USIDR; // LSB 1:data 0:command
        USIDR = rcvdat;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli(); // sei();

        do{
            PORTB = (USISR & 0x0F) | 0x80; // debug LED
        } while( !((bfusicnt = USISR) & (1<<USIOIF)) );
        for(i = 0; i++ < 4;) { uchar bytdmy; // one loop 11 clock (33 clock = 2.7u SEC.)
            if((uchar)(bytdmy= ((bfusicnt ^ USISR) & 0x0F) )) i = 0, bfusicnt = USISR;
        }
        if(USISR & 0x0F) { // error
            PORTB &= ~(1<<PB7); // pull-up off
            USICR = 0;
            goto idoltp;
        }
        rcvdat = USIDR;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        PORTB &= ~(1<<PB7); // pull-up off
        while( !(USISR & 0x0E) ) ; // 2 times occurred
        USICR = 0;
        PORTB = (rcvdat & 0x0F) | 0x10; // debug LED

if(!tst1) {
    tst1 = 1;
        rcvdat ^= 0xFF;
        for(i=5; i--;) PORTB &= ~(1<<PB7); // wait 2.1u SEC.
        //PORTB &= ~(1<<PB7); // pull-up off
        do {                                // slave trigger
            DDRB |= (1<<PB7);
            for(i=17; i--;) PORTB &= ~(1<<PB7); // wait 7.1u SEC.
            DDRB &= ~(1<<PB7);
            for(i=4; i--;) PORTB &= ~(1<<PB7); // wait 1.7u SEC.
        } while(PINB & (1<<PB7)) ;
        for(i=5; i--;) PORTB &= ~(1<<PB7); // wait 2.1u SEC.
        goto srvt;
}
    }
*/
/* test 3
    PORTB = 0x15;    // all pullups except PB5, PB7
    DDRB = (1<<PB6) | 0x1F; // all inputs include PB5(~RTS) except PB6(~CTS) output

    PORTB &= ~(1<<PB7); // pull-up off
    rcvdat = 0x12;
    while(1) { uchar bfusicnt, i;
idoltp: for(i = 0; i++ < 18;) { // one loop 7 clock (35 clock = 10u SEC.)
            if(PINB & (1<<PB7)) goto idoltp; }
        USICR = (1<<USIWM0) | (1<<USICS1);
        USIDR = 0;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli();
        PORTB |= (1<<PB7); // pull-up on
        while( !(USISR & 0x0F) ) ;
        USIDR = rcvdat;
        USISR = (1<<USIOIF) | 0; // USICNT = 0
        cli(); // sei();

        do{
            PORTB = (USISR & 0x0F) | 0x80;
        } while( !((bfusicnt = USISR) & (1<<USIOIF)) );
        for(i = 0; i++ < 4;) { uchar bytdmy; // one loop 11 clock (33 clock = 2.7u SEC.)
            if((uchar)(bytdmy= ((bfusicnt ^ USISR) & 0x0F) )) i = 0, bfusicnt = USISR;
        }
        //if(USISR & 0x0F) ; // error
        rcvdat = USIDR;
        USICR = 0;
        PORTB &= ~(1<<PB7); // pull-up off
        PORTB = (rcvdat & 0x0F) | 0x10;
    }
*/
/* test 1
    PORTB = 0x9F;    // all pullups except PB5
    DDRB = (1<<PB6) | 0x1F; // all inputs include PB5(~RTS) except PB6(~CTS) output

    PORTB |= (1 << PB7);
    USICR = (1 << USIWM0) | (1 << USICS1);
    USISR = (1 << USIOIF) | 14; // USICNT = 14

    rcvdat = 0x12;
    while(1) { uchar bfusicnt, i;
    //if(PORTB & (1 << PB7)) { // pull-up on
        do{
            PORTB = (USISR & 0x0F) | 0x80;
        } while( !((bfusicnt = USISR) & (1 << USIOIF)) );
        for(i = 0; i++ < 4;) { uchar bytdmy; // one loop 11 clock
            if((uchar)(bytdmy= ((bfusicnt ^ USISR) & 0x0F) )) i = 0, bfusicnt = USISR;
        }
        //if(USISR & 0x0F) ; // error
        USISR = 0; // USICNT = 0
        PORTB &= ~(1 << PB7); // pull-up off
        while( !(USISR & 0x0F) ) ;
        USIDR = rcvdat;
        USISR = (1 << USIOIF); // USICNT = 0
    //}else{ // pull-up off
        do{
            PORTB = (USISR & 0x0F);
        } while( !((bfusicnt = USISR) & (1 << USIOIF)) );
        for(i = 0; i++ < 4;) { uchar bytdmy; // one loop 11 clock
            if((uchar)(bytdmy= ((bfusicnt ^ USISR) & 0x0F) )) i = 0, bfusicnt = USISR;
        }
        //if(USISR & 0x0F) ; // error
        USISR = 0; // USICNT = 0
        PORTB = ((rcvdat = USIDR) & 0x0F) | 0x10;
        PORTB |= (1 << PB7); // pull-up on
        while( !(USISR & 0x0F) ) ;
        USISR = (1 << USIOIF) | 14; // USICNT = 14
        while( !((USISR ^ 14) & 0x0F) ) ; // for data display to LED
    //}
    }
*/
/* test 0
    PORTB = 0x9F;    // all pullups except PB5
    DDRB = (1<<PB6) | 0x1F; // all inputs include PB5(~RTS) except PB6(~CTS) output

    PORTB |= (1 << PB7);
    USICR = (1 << USIWM0) | (1 << USICS1);
    USISR = (1 << USIOIF) | 0;

while(1) { uchar bfusicnt, i;
    if(PORTB & (1 << PB7)) { // pull-up on
        do{
            PORTB = (USISR & 0x0F) | 0x80;
        } while( !((bfusicnt = USISR) & (1 << USIOIF)) );
        for(i = 0; i++ < 4;) { uchar j; // one loop 11 clock
            j = (bfusicnt ^ USISR) & 0x0F;
            if(j) i = 0, bfusicnt = USISR;
        }
        USISR = 0;
        PORTB = (USIDR & 0x0F) | 0x90;
        PORTB &= ~(1 << PB7); // pull-up off
        while( !(USISR & 0x0F) ) ;
        USISR = (1 << USIOIF);
        while( !(USISR & 0x0F) ) ; // for data display to LED 
    }else{ // pull-up off
        do{
            PORTB = (USISR & 0x0F);
        } while( !((bfusicnt = USISR) & (1 << USIOIF)) );
        for(i = 0; i++ < 4;) { uchar j; // one loop 11 clock
            j = (bfusicnt ^ USISR) & 0x0F;
            if(j) i = 0, bfusicnt = USISR;
        }
        USISR = 0;
        PORTB = ((i = USIDR) & 0x0F) | 0x10;
        PORTB |= (1 << PB7); // pull-up on
        while( !(USISR & 0x0F) ) ;
        USIDR = i;
        USISR = (1 << USIOIF);
        while( !(USISR & 0x0F) ) ; // for data display to LED
    }
}
*/
